<template>
  <svg :viewBox="`0 0 ${viewWidth} ${viewHeight}`">
    <!-- Grid -->
    <g>
      <!-- Years and months if needed -->
      <template v-if="!element">
        <text v-for="year in yearsAndMonths.years"
              :key="year.year"
              :x="year.x + 10"
              :y="viewHeight - 25"
              class="gpa-months-graph__years">{{ year.year }}</text>
        <text v-for="month in yearsAndMonths.months"
              :key="month.name"
              :x="month.x + 10"
              :y="viewHeight - 10"
              class="gpa-months-graph__months">{{ month.name }}</text>
      </template>
      <line v-for="month in yearsAndMonths.months"
            :key="month.name"
            :x1="month.x"
            y1="0"
            :x2="month.x"
            :y2="viewHeight"
            class="gpa-months-graph__line" />
    </g>

    <!-- Sowing/harvesting months -->
    <template v-if="element">
      <rect v-for="x in shelteredSowingXs"
            :key="x"
            :x="x"
            y="1"
            :width="monthWidth"
            :height="viewHeight/3 - 1"
            stroke-width="0"
            class="gpa-months-graph__sheltered" />
      <rect v-for="x in soilSowingXs"
            :key="x"
            :x="x"
            :y="viewHeight/3"
            :width="monthWidth"
            :height="viewHeight/3 - 1"
            stroke-width="0"
            class="gpa-months-graph__soil" />
      <rect v-for="x in harvestingXs"
            :key="x"
            :x="x"
            :y="viewHeight/3*2"
            :width="monthWidth"
            :height="viewHeight/3 - 1"
            stroke-width="0"
            class="gpa-months-graph__harvest" />

      <!-- Data -->
      <template v-if="element.isImplanted || element.isImplantationPlanned || element.isRemoved">
        <!-- Lifetime when defined, or only period to today -->
        <line v-if="(endPosition || todayX) > startPosition"
              :x1="startPosition"
              :x2="endPosition || todayX"
              :y1="viewHeight/2"
              :y2="viewHeight/2"
              class="gpa-months-graph__bar"
              :class="barCSS" />
        <!-- Removal overdue -->
        <template v-if="element.isRemovalOverdue">
          <line :x1="endPosition || todayX"
                :x2="todayX"
                :y1="viewHeight/2"
                :y2="viewHeight/2"
                data-overdue="true"
                class="gpa-months-graph__bar--removal-overdue-to-today" />
          <!-- Removal overdue -->
          <line :x1="todayX"
                :x2="viewWidth"
                :y1="viewHeight/2"
                :y2="viewHeight/2"
                data-overdue="true"
                class="gpa-months-graph__bar--no-planned-removal" />
        </template>
        <!-- Unknown period after today -->
        <line v-if="!elementEndDate && !endPosition"
              :x1="(startPosition < todayX) ? todayX : startPosition"
              :x2="viewWidth"
              :y1="viewHeight/2"
              :y2="viewHeight/2"
              class="gpa-months-graph__bar--no-planned-removal" />
        <rui-icon v-if="invisibleOnLeft"
                  name="caret-left"
                  :x="-viewWidth/2+10"
                  :y="(viewHeight - 15)/2"
                  :height="15" />
        <rui-icon v-if="invisibleOnRight"
                  name="caret-right"
                  :x="viewWidth/2-10"
                  :y="(viewHeight - 15)/2"
                  :height="15" />
      </template>
      <line v-else
            :x1="0"
            :x2="viewWidth"
            :y1="viewHeight/2"
            :y2="viewHeight/2"
            class="gpa-months-graph__not-planned" />
    </template>

    <!-- Today -->
    <line :x1="todayX"
          y1="0"
          :x2="todayX"
          :y2="viewHeight"
          class="gpa-months-graph__today" />
  </svg>
</template>

<script>
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'

import { isAfter, isBefore } from '@experiments-labs/rise_ui/src/lib/Dates'
import Element from '../../../../classes/models/Element'

/**
 * @typedef {import('../../../../classes/models/Resource')} Resource
 */

export default {
  name: 'GpaMonthsGraph',
  components: { RuiIcon },
  props: {
    /** Element to display */
    element: { required: false, type: Element, default: null },
    /** Total number of months to display */
    months: { required: false, type: Number, default: 12 },
    /** Months before the provided reference date */
    before: { required: false, type: Number, default: 2 },
    /** Reference date */
    reference: { required: false, type: Date, default: () => { return new Date() } },
    /** Graph width, in pixels */
    width: { required: false, type: Number, default: 900 },
  },
  data () {
    return {
      viewHeight: 35,
    }
  },
  computed: {
    /** @type {number} Width for a month in px */
    monthWidth () { return this.$props.width / 12 },
    /**
     * Totally inaccurate but still better than trying to compute precision
     * values with a good day/pixels scale in JS
     *
     * @type {number} Width of a day in px
     */
    dayWidth () { return this.monthWidth / 30 },
    /** @type {Resource} - Associated resource */
    resource () { return this.element.resource },
    /** @type {[number, number][]} - List of `[x, width]` of soil sowing months */
    soilSowingXs () { return this.monthsX(this.resource.soilSowingMonths) },
    /** @type {[number, number][]} - List of `[x, width]` of sheltered sowing months */
    shelteredSowingXs () { return this.monthsX(this.resource.shelteredSowingMonths) },
    /** @type {[number, number][]} - List of `[x, width]` of harvesting months */
    harvestingXs () { return this.monthsX(this.resource.harvestingMonths) },
    /** @type {number} - X position for today */
    todayX () { return this.calcX(new Date()) },
    /** @type {Date} - Starting date of the representation */
    viewStartDate () {
      const date = this.datePlusMonths(this.reference, (-this.before))
      // First day of the month
      date.setDate(1)
      return date
    },
    /** @type {Date} - Ending date of the representation */
    viewEndDate () {
      const date = this.datePlusMonths(this.viewStartDate, this.months)
      // Last day of previous month
      date.setDate(0)
      return date
    },
    /** @type {number} - Total view box width, depending on the amount of months to show */
    viewWidth () { return this.monthWidth * this.months },
    /** @type {{years: {year: number, x: number}[], months: {number: number, name: string, x: number, date: Date}[]}} - List of months to build the view */
    yearsAndMonths () {
      const years = []
      const data = { years: [], months: [] }
      const date = new Date(this.reference)
      date.setMonth(date.getMonth() - this.before)

      let number = date.getMonth()
      for (let i = 0; i < 12; i++) {
        const year = date.getFullYear()
        const x = this.monthWidth * i

        if (!years.includes(year)) {
          years.push(year)
          data.years.push({ year, x })
        }

        data.months.push({
          number,
          name: this.$tm('date.abbr_month_names')[number + 1],
          x,
          date: new Date(date),
        })

        date.setMonth(date.getMonth() + 1)
        number++
        if (number === 12) { number = 0 }
      }

      return data
    },
    /** @type {Date|null} - Potential date to use as start date */
    elementStartDate () { return this.element.implantedAt || this.element.implantationPlannedFor },
    /** @type {Date|null} - Potential date to use as end date */
    elementEndDate () { return this.element.removedAt || this.element.removalPlannedFor },
    /** @type {number|null} - Starting X position of the Element representation */
    startPosition () {
      if (!this.elementStartDate) return null

      return this.calcX(this.elementStartDate)
    },
    /** @type {number|null} - Ending X position of the Element representation */
    endPosition () {
      if (!this.elementEndDate) return null

      return this.calcX(this.elementEndDate)
    },
    invisibleOnLeft () { return this.elementEndDate && isBefore(this.viewStartDate, this.elementEndDate) },
    invisibleOnRight () { return this.elementStartDate && isAfter(this.viewEndDate, this.elementStartDate) },
    /** @type {string} CSS class to apply to the Element representation */
    barCSS () {
      if (this.element.isRemoved) return 'gpa-months-graph__bar--removed'
      if (this.element.isImplantationOverdue) return 'gpa-months-graph__bar--overdue'

      return ''
    },
  },
  methods: {
    /**
     * @param   {Date}   date - Date to position
     * @returns {number}      Position in pixels
     */
    calcX (date) {
      if (isBefore(this.viewStartDate, date)) return 0
      if (isAfter(this.viewEndDate, date)) return this.viewWidth

      const month = this.yearsAndMonths.months.find(m => m.number === date.getMonth())
      const daysX = (date.getDate() - 1) * this.dayWidth

      return month.x + daysX
    },
    /**
     * Calculates the X and widths for sowing/harvesting months of the Resource
     *
     * @param   {boolean[]}          months - Value from the Resource
     * @returns {[number, number][]}        - The list of numbers to use for the representation of each used month
     */
    monthsX (months) {
      const list = []
      for (const month of this.yearsAndMonths.months) {
        if (months[month.number]) { list.push(month.x) }
      }
      return list
    },
    /**
     * Adds an amount of months to a date and returns a copy
     *
     * @param   {Date}   date   - Reference date
     * @param   {number} months - Amount of months to add
     * @returns {Date}          - New Date instance
     */
    datePlusMonths (date, months) {
      const newDate = new Date(date)
      newDate.setMonth(date.getMonth() + months)
      return newDate
    },
  },
}
</script>

<style lang="scss" src="./_MonthsGraph.scss" />
